package org.zeichner.winner.ui.fields.textfield;

import org.fxmisc.richtext.model.StyleSpan;
import org.fxmisc.richtext.model.StyleSpans;
import org.fxmisc.richtext.model.StyleSpansBuilder;

import java.util.*;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.util.stream.Stream;

import static org.zeichner.winner.formatio.ertr.LexerConstants.*;
import static org.zeichner.winner.formatio.ertr.LexerModifiers.*;

/**
 * Computes the highlighting for the {@link TextField}.
 */
public class ERTRHighlighting {

    // CSS class names (see text-style.css)
    private static Collection<String> KEYWORD_STYLE_CLASS = Collections.singleton("keyword");
    private static Collection<String> CARDINALITY_STYLE_CLASS = Collections.singleton("cardinality");
    private static Collection<String> PRIMARY_KEY_STYLE_CLASS = Collections.singleton("primary_key");
    private static Collection<String> NO_STYLE_CLASS = Collections.emptyList();
    private static Collection<String> SYNTAX_ERROR_STYLE_CLASS = Collections.singleton("syntax_error");

    // A pattern which captures all to-be-highlighted parts
    private static final Pattern HIGHLIGHT_PATTERN = Pattern.compile(
            standalone(oneOf(
                    record(oneOf(IS_A_LITERAL, PART_OF_LITERAL, WEAK_LITERAL, ENTITY_LITERAL, AT_LITERAL), "k"),
                    record(CARDINALITY, "c"),
                    record(PRIMARY_KEY, "p")
            ))
    );

    /**
     * Computes <code>ERTR</code> syntax highlighting for the given text.
     */
    public static StyleSpans<Collection<String>> computeSyntaxHighlighting(String str){
        StyleSpansBuilder<Collection<String>> builder = new StyleSpansBuilder<>();

        Matcher matcher = HIGHLIGHT_PATTERN.matcher(str);
        int lastMatchEnd = 0;
        while(matcher.find()){
            // Get the CSS styleclass according to the matched group.
            Collection<String> styleclass =
                    matcher.group("k") != null? KEYWORD_STYLE_CLASS :
                    matcher.group("c") != null? CARDINALITY_STYLE_CLASS :
                    matcher.group("p") != null? PRIMARY_KEY_STYLE_CLASS : NO_STYLE_CLASS;

            // Fill the space between the last match and this match with no style.
            builder.add(NO_STYLE_CLASS, matcher.start() - lastMatchEnd);
            // Apply style to match
            builder.add(styleclass, matcher.end() - matcher.start());
            lastMatchEnd = matcher.end();
        }

        builder.add(NO_STYLE_CLASS, str.length() - lastMatchEnd);
        return builder.create();
    }

    /**
     * Computes the syntax error highlighting given the given error indexes. The
     * entries with an even access index (e.g. <code>idx[0]</code>, <code>idx[2]</code>)
     * correspond to the start indexes of errors, and all odd numbers to the end indexes.
     * As such this list is always sorted.
     *
     * Example content:
     * <pre>
     *     3, 10, 15, 33
     * </pre>
     * Means everything between 3 (included) and 10 (not included), 15 and 33 is invalid.
     *
     * @param length the total text length
     * @param idx the error indexes
     */
    public static StyleSpans<Collection<String>> computeErrorHighlighting(int length, int... idx){
        if(idx.length % 2 != 0){
            throw new IllegalArgumentException("Error id count must be even.");
        }

        StyleSpansBuilder<Collection<String>> builder = new StyleSpansBuilder<>();
        int lastMatchEnd = 0;

        // Iterate over all start and end values
        for(int i = 1; i < idx.length; i += 2){
            // Apply no style until this style class
            builder.add(NO_STYLE_CLASS, idx[i - 1] - lastMatchEnd);
            // Apply the syntax_error CSS class to the whole match
            builder.add(SYNTAX_ERROR_STYLE_CLASS, idx[i] - idx[i - 1]);
            lastMatchEnd = idx[i];
        }

        builder.add(NO_STYLE_CLASS, length - lastMatchEnd);

        return builder.create();
    }

    /**
     * Combines one or more {@link StyleSpans} to a result span. If only one span is provided,
     * said span is returned. Otherwise, the span is generated by splitting all spans into
     * subspans and combining the styles for each position, e.g.:
     *
     * Given the argument spans <code>a</code> and <code>b</code>
     * (where capital letters denote styles) the result is <code>r</code>:
     *
     * <pre>
     *            A      B       A
     *     a = |-----|-------|-------|
     *              C      D   C   D
     *     b = |---------|---|---|---|
     *           A,C  B,C B,D A,C A,D
     *     r = |-----|---|---|---|---|
     * </pre>
     *
     * @param first The first span. Used to enforce at least one argument.
     * @param rest The rest of the to-be-combined spans.
     * @throws IllegalArgumentException - thrown if there are two spans which length is not the same.
     * @throws IllegalStateException - if the impossible happens
     * @return The combination of all spans, as seen above.
     */
    @SafeVarargs
    public static StyleSpans<Collection<String>> combine(StyleSpans<Collection<String>> first, StyleSpans<Collection<String>>... rest){
        // 'reduce' Combines each two spans using combineTwo. E.g. given the spans:
        //     a, b, c
        // this method is identical to calling
        //     combineTwo(combineTwo(a, b), c)
        return Stream.concat(Stream.of(first), Arrays.stream(rest))
                .reduce(ERTRHighlighting::combineTwo)
                .orElseThrow(IllegalStateException::new); // Can not happen, at least one args is provided
    }

    private static <T> StyleSpans<Collection<T>> combineTwo(StyleSpans<Collection<T>> a, StyleSpans<Collection<T>> b){
        if(a.length() != b.length()){
            throw new IllegalArgumentException("Length of all syntax highlighting spans must be equal.");
        }

        StyleSpansBuilder<Collection<T>> builder = new StyleSpansBuilder<>();
        Comparator<StyleSpan<Collection<T>>> comp = Comparator.comparing(StyleSpan::getLength);

        // The index of each span(s)
        int aIdx = 0, bIdx = 0;

        // The length modifier for each span
        int bLenMod = 0; int aLenMod = 0;

        // Iterate over all style spans of both spans
        while(aIdx < a.getSpanCount() && bIdx < b.getSpanCount()){

            StyleSpan<Collection<T>> spanOrigA = a.getStyleSpan(aIdx);
            StyleSpan<Collection<T>> spanOrigB = b.getStyleSpan(bIdx);

            // We are re-creating the spans with same same style, but substracting the
            // length modifier from the original length.
            StyleSpan<Collection<T>> spanA = new StyleSpan<>(spanOrigA.getStyle(), spanOrigA.getLength() - aLenMod);
            StyleSpan<Collection<T>> spanB = new StyleSpan<>(spanOrigB.getStyle(), spanOrigB.getLength() - bLenMod);

            // An array containing the styles of both current spans
            List<T> styles = new ArrayList<>();
            styles.addAll(spanA.getStyle());
            styles.addAll(spanB.getStyle());

            // Compare the length of the current spans, then apply the 'styles' to
            // the smallest span length. E.g. if the SpanA has the length 3, and
            // SpanB has the length 10, the generated span will be of size 3 and
            // contain the style of BOTH SpanA and SpanB
            switch(comp.compare(spanA, spanB)){
                // spanA.getLength() = spanB.getLength()
                case 0:
                    builder.add(styles, spanB.getLength());

                    aLenMod = 0;
                    bLenMod = 0;

                    aIdx++;
                    bIdx++;
                    break;
                // spanA.getLength() > spanB.getLength()
                case 1:
                    builder.add(styles, spanB.getLength());

                    aLenMod += spanB.getLength();
                    bLenMod = 0;

                    bIdx++;
                    break;
                // spanA.getLength() < spanB.getLength()
                case -1:
                    builder.add(styles, spanA.getLength());

                    bLenMod += spanA.getLength();
                    aLenMod = 0;

                    aIdx++;
                    break;
            }
        }

        return builder.create();
    }
}
